;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module __caml_dump
  (foreign (include #"caml-bigloo.h"))
  (import
   (__caml_typing #"typing.scm")
   (__caml_ty_decl #"ty_decl.scm")
   (__caml_lam #"lam.scm")
   (__caml_front #"front.scm")
   (__caml_compiler #"compiler.scm")
   (__caml_pr_decl #"pr_decl.scm")
   (__caml_location #"location.scm")
   (__caml_misc #"misc.scm")
   (__caml_modules #"modules.scm")
   (__caml_ty_intf #"ty_intf.scm")
   (__caml_prim #"prim.scm")
   (__caml_emit_phr #"emit_phr.scm")
   (__caml_instruct #"instruct.scm")
   (__caml_ty_error #"ty_error.scm")
   (__caml_types #"types.scm")
   (__caml_globals #"globals.scm")
   (__caml_builtins #"builtins.scm")
   (__caml_syntax #"syntax.scm")
   (__caml_parser #"parser.scm")
   (__caml_lexer #"lexer.scm")
   (__caml_const #"const.scm"))
  (include
   #"location.sci"
   #"parser.sci"
   #"lexer.sci")
  (export
   (dump_impl_phrase_211@dump x1)
   (2-13-dump_impl_phrase_211@dump x1 x2)
   (dump_imports_34@dump x1)
   (2-133-dump_imports_34@dump x1 x2)
   (dump_impl_61@dump x1)
   (2-18-dump_impl_61@dump x1 x2)
   (dump_syntax_implementation_69@dump x1)
   (2-63-dump_syntax_implementation_69@dump x1 x2)
   mklib_84@dump
   prims_to_dump_51@dump
   scheme_prims_to_dump_236@dump
   (dump_intf_phrase_160@dump x1)
   (write_one_decl_74@dump x1)
   (2-149-write_one_decl_74@dump x1 x2)
   (write_one_scheme_decl_216@dump x1)
   (2-79-write_one_scheme_decl_216@dump x1 x2)
   (write_dumped_interface_16@dump x1)
   (2-172-write_dumped_interface_16@dump x1 x2)
   (dump_interface_92@dump x1)
   (2-199-dump_interface_92@dump x1 x2)))

;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(begin
  (define dump_impl_phrase_211@dump
    (lambda (x1)
      (lambda (x2)
        (2-13-dump_impl_phrase_211@dump x1 x2))))
 (define 2-13-dump_impl_phrase_211@dump
    (lambda (x1 x2)
      (begin
        (reset_type_expression_vars_117@typing #f)
        (let ((x3 (caml-constr-get-field x2 0)))
          (case (caml-regular-constr-tag x3)
            ((1)
             (let ((x4 ((type_expression_168@ty_decl
                          (caml-constr-get-field x2 1))
                        (caml-constr-get-field x3 0))))
               (begin
                 (((dump_lambda_193@lam x1) #f)
                  (translate_expression_98@front
                    (caml-constr-get-field x3 0)))
                 (if (cell-ref verbose_226@compiler)
                   (print_expr_98@pr_decl x4)
                   #f))))
            ((2)
             (let ((x4 (((type_letdef_82@ty_decl
                           (caml-constr-get-field x2 1))
                         (caml-constr-get-field x3 0))
                        (caml-constr-get-field x3 1))))
               (begin
                 (if (caml-constr-get-field x3 0)
                   (((dump_lambda_193@lam x1) #t)
                    ((translate_letdef_rec_253@front
                       (caml-constr-get-field x2 1))
                     (caml-constr-get-field x3 1)))
                   (((dump_lambda_193@lam x1) #f)
                    ((translate_letdef_153@front
                       (caml-constr-get-field x2 1))
                     (caml-constr-get-field x3 1))))
                 (if (cell-ref verbose_226@compiler)
                   (print_valdef_178@pr_decl x4)
                   #f))))
            ((3)
             (let ((x4 ((type_typedecl_239@ty_decl
                          (caml-constr-get-field x2 1))
                        (caml-constr-get-field x3 0))))
               (if (cell-ref verbose_226@compiler)
                 (print_typedecl_247@pr_decl x4)
                 #f)))
            ((4)
             (let ((x4 ((type_excdecl_123@ty_decl
                          (caml-constr-get-field x2 1))
                        (caml-constr-get-field x3 0))))
               (if (cell-ref verbose_226@compiler)
                 (print_excdecl_200@pr_decl x4)
                 #f)))
            (else
             (do_directive_88@compiler
               (caml-constr-get-field x3 0))))))))
)
(begin
  (define dump_imports_34@dump
    (lambda (x1)
      (lambda (x2) (2-133-dump_imports_34@dump x1 x2))))
 (define 2-133-dump_imports_34@dump
    (lambda (x1 x2)
      ((do_list_18@list
         (lambda (x3)
           (begin
             ((output_string_156@io x1) #"(import ")
             (begin
               ((output_string_156@io x1)
                (caml-constr-get-field x3 0))
               (begin
                 ((output_string_156@io x1) #" \"")
                 (begin
                   ((output_string_156@io x1)
                    (caml-constr-get-field x3 1))
                   ((output_string_156@io x1) #"\")\n")))))))
       x2)))
)
(begin
  (define dump_impl_61@dump
    (lambda (x1)
      (lambda (x2) (2-18-dump_impl_61@dump x1 x2))))
 (define 2-18-dump_impl_61@dump
    (lambda (x1 x2)
      (let ((x3 ((^_54@fstring x2) #".ml"))
            (x4 ((^_54@fstring x2) #".lam")))
        (let ((x5 (open_in_bin_161@io x3))
              (x6 (open_out_142@io x4)))
          (let ((x7 (create_lexer_channel_186@lexing x5)))
            (begin
              (cell-set! input_name_202@location x3)
              (begin
                (cell-set! input_chan_27@location x5)
                (begin
                  (cell-set! input_lexbuf_35@location x7)
                  (let* ((handler-top1001 current_handler)
                         (:-d.1002 (unspecified)))
                    (labels
                      ((try1004
                         (:-d.1002)
                         (begin
                           (get-the-continuation :-d.1002)
                           (if (eq? #t #f) (try1004 (try1004 (try1004 1))))
                           (if :-d.1002
                             (let :-d.1003 ()
                               (if #t
                                 (begin
                                   ((dump_impl_phrase_211@dump x6)
                                    (parse_impl_phrase_21@compiler x7))
                                   (:-d.1003))
                                 '()))
                             current_handler))))
                      (let ((x8 (try1004 :-d.1002)))
                        (set! current_handler handler-top1001)
                        (if (=fx *try* 1)
                          (begin
                            (set! *try* 0)
                            (labels
                              ((staticfail1005
                                 ()
                                 (begin
                                   (close_in x5)
                                   (begin
                                     (close_out x6)
                                     (begin
                                       (remove_file_255@misc x4)
                                       (raise x8))))))
                              (case (caml-extensible-constr-tag x8)
                                ((end_of_file_1@io)
                                 (begin
                                   ((dump_imports_34@dump x6)
                                    (get_ever_opened_modules_184@modules #f))
                                   (begin (close_in x5) (close_out x6))))
                                (else (staticfail1005)))))
                          x8))))))))))))
)
(begin
  (define dump_syntax_implementation_69@dump
    (lambda (x1)
      (lambda (x2)
        (2-63-dump_syntax_implementation_69@dump x1 x2))))
 (define 2-63-dump_syntax_implementation_69@dump
    (lambda (x1 x2)
      (begin
        (cell-set! external_types_124@ty_decl '())
        (if (file_exists_172@misc
              ((^_54@fstring x2) #".mli"))
          (let* ((handler-top1007 current_handler)
                 (:-d.1008 (unspecified)))
            (labels
              ((try1013
                 (:-d.1008)
                 (begin
                   (get-the-continuation :-d.1008)
                   (if (eq? #t #f) (try1013 (try1013 (try1013 1))))
                   (if :-d.1008
                     (let ((x3 (read_module_102@modules
                                 ((^_54@fstring x2) #".zi"))))
                       (begin
                         ((start_compiling_implementation_91@modules x1)
                          x3)
                         (begin
                           (enter_interface_definitions_230@ty_intf x3)
                           (begin
                             ((dump_impl_61@dump x1) x2)
                             (begin
                               (check_interface_106@ty_intf x3)
                               (begin
                                 (if (cell-ref write_extended_zi_52@compiler)
                                   (let ((x4 ((^_54@fstring x2) #".zix")))
                                     (let ((x5 (open_out_bin_83@io x4)))
                                       (let* ((handler-top1010 current_handler)
                                              (:-d.1011 (unspecified)))
                                         (labels
                                           ((try1012
                                              (:-d.1011)
                                              (begin
                                                (get-the-continuation :-d.1011)
                                                (if (eq? #t #f)
                                                  (try1012
                                                    (try1012 (try1012 1))))
                                                (if :-d.1011
                                                  (begin
                                                    (write_compiled_interface_99@modules
                                                      x5)
                                                    (close_out x5))
                                                  current_handler))))
                                           (let ((x6 (try1012 :-d.1011)))
                                             (set! current_handler
                                               handler-top1010)
                                             (if (=fx *try* 1)
                                               (begin
                                                 (set! *try* 0)
                                                 (begin
                                                   (close_out x5)
                                                   (begin
                                                     (remove_file_255@misc x4)
                                                     (raise x6))))
                                               x6))))))
                                   #f)
                                 (kill_module_137@modules x1)))))))
                     current_handler))))
              (let ((x3 (try1013 :-d.1008)))
                (set! current_handler handler-top1007)
                (if (=fx *try* 1)
                  (begin
                    (set! *try* 0)
                    (begin
                      (remove_file_255@misc ((^_54@fstring x2) #".zo"))
                      (raise x3)))
                  x3))))
          (let ((x3 ((^_54@fstring x2) #".zi")))
            (let ((x4 (open_out_bin_83@io x3)))
              (let* ((handler-top1015 current_handler)
                     (:-d.1016 (unspecified)))
                (labels
                  ((try1017
                     (:-d.1016)
                     (begin
                       (get-the-continuation :-d.1016)
                       (if (eq? #t #f) (try1017 (try1017 (try1017 1))))
                       (if :-d.1016
                         (begin
                           (start_compiling_interface_242@modules x1)
                           (begin
                             ((dump_impl_61@dump x1) x2)
                             (begin
                               (write_compiled_interface_99@modules x4)
                               (close_out x4))))
                         current_handler))))
                  (let ((x5 (try1017 :-d.1016)))
                    (set! current_handler handler-top1015)
                    (if (=fx *try* 1)
                      (begin
                        (set! *try* 0)
                        (begin
                          (close_out x4)
                          (begin (remove_file_255@misc x3) (raise x5))))
                      x5))))))))))
)
(define mklib_84@dump (make-cell #f))
(define prims_to_dump_51@dump (make-cell '()))
(define scheme_prims_to_dump_236@dump
  (make-cell '()))

(define dump_intf_phrase_160@dump
  (lambda (x1)
    (let ((x2 (caml-constr-get-field x1 0)))
      (case (caml-regular-constr-tag x2)
        ((1)
         (let ((x3 (lambda (x3)
                     (labels
                       ((staticfail1018 () #f))
                       (case (if (caml-constant-constr?
                                   (caml-constr-get-field x3 2))
                               -1
                               (caml-regular-constr-tag
                                 (caml-constr-get-field x3 2)))
                         ((2)
                          (let ((:-d.1019
                                  (caml-constr-get-field
                                    (caml-constr-get-field x3 2)
                                    0)))
                            (cond ((eq? :-d.1019 #f)
                                   (case (if (caml-constant-constr?
                                               (caml-constr-get-field
                                                 (caml-constr-get-field x3 2)
                                                 2))
                                           -1
                                           (caml-regular-constr-tag
                                             (caml-constr-get-field
                                               (caml-constr-get-field x3 2)
                                               2)))
                                     ((11)
                                      (cell-set!
                                        prims_to_dump_51@dump
                                        (cons (caml-make-regular
                                                #f
                                                3
                                                (caml-constr-get-field x3 0)
                                                (caml-constr-get-field
                                                  (caml-constr-get-field
                                                    (caml-constr-get-field x3 2)
                                                    2)
                                                  0)
                                                (caml-constr-get-field
                                                  (caml-constr-get-field
                                                    (caml-constr-get-field x3 2)
                                                    2)
                                                  1))
                                              (cell-ref
                                                prims_to_dump_51@dump))))
                                     (else (staticfail1018))))
                                  (else
                                   (case (if (caml-constant-constr?
                                               (caml-constr-get-field
                                                 (caml-constr-get-field x3 2)
                                                 2))
                                           -1
                                           (caml-regular-constr-tag
                                             (caml-constr-get-field
                                               (caml-constr-get-field x3 2)
                                               2)))
                                     ((11)
                                      (cell-set!
                                        scheme_prims_to_dump_236@dump
                                        (cons (caml-make-regular
                                                #f
                                                3
                                                (caml-constr-get-field
                                                  (caml-constr-get-field
                                                    (caml-constr-get-field x3 2)
                                                    2)
                                                  0)
                                                (caml-constr-get-field
                                                  (caml-constr-get-field
                                                    (caml-constr-get-field x3 2)
                                                    0)
                                                  0)
                                                (caml-constr-get-field
                                                  (caml-constr-get-field
                                                    (caml-constr-get-field x3 2)
                                                    0)
                                                  1))
                                              (cell-ref
                                                scheme_prims_to_dump_236@dump))))
                                     (else (staticfail1018)))))))
                         (else (staticfail1018)))))))
           (begin
             ((type_valuedecl_23@ty_decl
                (caml-constr-get-field x1 1))
              (caml-constr-get-field x2 0))
             ((do_list_18@list x3)
              (caml-constr-get-field x2 0)))))
        ((2)
         (let ((x3 ((type_typedecl_239@ty_decl
                      (caml-constr-get-field x1 1))
                    (caml-constr-get-field x2 0))))
           (if (cell-ref verbose_226@compiler)
             (print_typedecl_247@pr_decl x3)
             #f)))
        ((3)
         (let ((x3 ((type_excdecl_123@ty_decl
                      (caml-constr-get-field x1 1))
                    (caml-constr-get-field x2 0))))
           (if (cell-ref verbose_226@compiler)
             (print_excdecl_200@pr_decl x3)
             #f)))
        (else
         (do_directive_88@compiler
           (caml-constr-get-field x2 0)))))))

(begin
  (define write_one_decl_74@dump
    (lambda (x1)
      (lambda (x2)
        (2-149-write_one_decl_74@dump x1 x2))))
 (define 2-149-write_one_decl_74@dump
    (lambda (x1 x2)
      (begin
        ((output_string_156@io x1)
         ((^_54@fstring #"      (obj ")
          ((^_54@fstring (caml-constr-get-field x2 1))
           #" (")))
        (begin
          (let ((stop1021 (-fx (caml-constr-get-field x2 2) 1)))
            (let for1020 ((i3 0))
              (if (<=fx i3 stop1021)
                (begin
                  ((output_string_156@io x1) #"obj ")
                  (for1020 (+fx i3 1)))
                (unspecified))))
          ((output_string_156@io x1)
           ((^_54@fstring #") \"")
            ((^_54@fstring (caml-constr-get-field x2 1))
             #"\")\n")))))))
)
(begin
  (define write_one_scheme_decl_216@dump
    (lambda (x1)
      (lambda (x2)
        (2-79-write_one_scheme_decl_216@dump x1 x2))))
 (define 2-79-write_one_scheme_decl_216@dump
    (lambda (x1 x2)
      ((output_string_156@io x1)
       ((^_54@fstring #"(")
        ((^_54@fstring (caml-constr-get-field x2 0))
         ((^_54@fstring #" ")
          ((^_54@fstring (caml-constr-get-field x2 1))
           ((^_54@fstring #" \"")
            ((^_54@fstring (caml-constr-get-field x2 2))
             #"\")\n")))))))))
)
(begin
  (define write_dumped_interface_16@dump
    (lambda (x1)
      (lambda (x2)
        (2-172-write_dumped_interface_16@dump x1 x2))))
 (define 2-172-write_dumped_interface_16@dump
    (lambda (x1 x2)
      (if (not (cell-ref mklib_84@dump))
        (let ((x3 ((^_54@fstring x2) #".sci")))
          (let ((x4 (open_out_142@io x3)))
            (let* ((handler-top1023 current_handler)
                   (:-d.1024 (unspecified)))
              (labels
                ((try1025
                   (:-d.1024)
                   (begin
                     (get-the-continuation :-d.1024)
                     (if (eq? #t #f) (try1025 (try1025 (try1025 1))))
                     (if :-d.1024
                       (begin
                         ((output_string_156@io x4) #"(directives ")
                         (begin
                           ((output_string_156@io x4) #"\n   (foreign\n")
                           (begin
                             ((do_list_18@list (write_one_decl_74@dump x4))
                              (cell-ref prims_to_dump_51@dump))
                             (begin
                               ((output_string_156@io x4) #")\n\n")
                               (begin
                                 ((output_string_156@io x4) #"\n   (import\n")
                                 (begin
                                   ((do_list_18@list
                                      (write_one_scheme_decl_216@dump x4))
                                    (cell-ref scheme_prims_to_dump_236@dump))
                                   (begin
                                     ((output_string_156@io x4) #"))\n\n")
                                     (close_out x4))))))))
                       current_handler))))
                (let ((x5 (try1025 :-d.1024)))
                  (set! current_handler handler-top1023)
                  (if (=fx *try* 1)
                    (begin
                      (set! *try* 0)
                      (begin
                        (close_out x4)
                        (begin (remove_file_255@misc x3) (raise x5))))
                    x5))))))
        #f)))
)
(begin
  (define dump_interface_92@dump
    (lambda (x1)
      (lambda (x2)
        (2-199-dump_interface_92@dump x1 x2))))
 (define 2-199-dump_interface_92@dump
    (lambda (x1 x2)
      (let ((x3 ((^_54@fstring x2) #".mli"))
            (x4 ((^_54@fstring x2) #".zi")))
        (let ((x5 (open_in_bin_161@io x3))
              (x6 (open_out_bin_83@io x4)))
          (let* ((handler-top1027 current_handler)
                 (:-d.1028 (unspecified)))
            (labels
              ((try1030
                 (:-d.1028)
                 (begin
                   (get-the-continuation :-d.1028)
                   (if (eq? #t #f) (try1030 (try1030 (try1030 1))))
                   (if :-d.1028
                     (begin
                       (start_compiling_interface_242@modules x1)
                       (let ((x7 (create_lexer_channel_186@lexing x5)))
                         (begin
                           (cell-set! input_name_202@location x3)
                           (begin
                             (cell-set! input_chan_27@location x5)
                             (begin
                               (cell-set! input_lexbuf_35@location x7)
                               (begin
                                 (cell-set! external_types_124@ty_decl '())
                                 (let :-d.1029 ()
                                   (if #t
                                     (begin
                                       (dump_intf_phrase_160@dump
                                         (parse_intf_phrase_10@compiler x7))
                                       (:-d.1029))
                                     '()))))))))
                     current_handler))))
              (let ((x7 (try1030 :-d.1028)))
                (set! current_handler handler-top1027)
                (if (=fx *try* 1)
                  (begin
                    (set! *try* 0)
                    (labels
                      ((staticfail1031
                         ()
                         (begin
                           (close_in x5)
                           (begin
                             (close_out x6)
                             (begin (remove_file_255@misc x4) (raise x7))))))
                      (case (caml-extensible-constr-tag x7)
                        ((end_of_file_1@io)
                         (begin
                           (close_in x5)
                           (begin
                             (write_compiled_interface_99@modules x6)
                             (begin
                               ((write_dumped_interface_16@dump x1) x2)
                               (close_out x6)))))
                        (else (staticfail1031)))))
                  x7))))))))
)
