;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module __caml_prim_opc
  (foreign (include #"caml-bigloo.h"))
  (import
   (__caml_misc #"misc.scm")
   (__caml_opcodes #"opcodes.scm")
   (__caml_globals #"globals.scm")
   (__caml_prim #"prim.scm"))
  (include)
  (export
   (opcode_for_primitive_27@prim_opc x1)
   (opcode_for_float_primitive_146@prim_opc x1)))

;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define opcode_for_primitive_27@prim_opc
  (lambda (x1)
    (labels
      ((staticfail1000
         ()
         (fatal_error_193@misc #"opcode_for_primitive")))
      (let ((:-d.1001 x1))
        (cond ((eq? :-d.1001 #a000) update_132@opcodes)
              ((eq? :-d.1001 #<000c>) raise_41@opcodes)
              ((eq? :-d.1001 #<000d>) boolnot_123@opcodes)
              ((eq? :-d.1001 #<0008>) tagof_105@opcodes)
              ((eq? :-d.1001 #<000e>) negint_130@opcodes)
              ((eq? :-d.1001 #<000f>) succint_67@opcodes)
              ((eq? :-d.1001 #<0010>) predint_236@opcodes)
              ((eq? :-d.1001 #<0011>) addint_163@opcodes)
              ((eq? :-d.1001 #<0012>) subint_74@opcodes)
              ((eq? :-d.1001 #<0013>) mulint_80@opcodes)
              ((eq? :-d.1001 #<0014>) divint_14@opcodes)
              ((eq? :-d.1001 #<0015>) modint_119@opcodes)
              ((eq? :-d.1001 #<0016>) andint_198@opcodes)
              ((eq? :-d.1001 #<0017>) orint_128@opcodes)
              ((eq? :-d.1001 #<0018>) xorint_176@opcodes)
              ((eq? :-d.1001 #<0019>) shiftleftint_166@opcodes)
              ((eq? :-d.1001 #<001a>)
               shiftrightintsigned_145@opcodes)
              ((eq? :-d.1001 #<001b>)
               shiftrightintunsigned_75@opcodes)
              ((eq? :-d.1001 #<001c>) incr_93@opcodes)
              ((eq? :-d.1001 #<001d>) decr_38@opcodes)
              ((eq? :-d.1001 #<001e>) intoffloat_123@opcodes)
              ((eq? :-d.1001 #<0020>) stringlength_31@opcodes)
              ((eq? :-d.1001 #<0021>) getstringchar_83@opcodes)
              ((eq? :-d.1001 #<0022>)
               setstringchar_251@opcodes)
              ((eq? :-d.1001 #<0023>) makevector_165@opcodes)
              ((eq? :-d.1001 #<0024>) vectlength_45@opcodes)
              ((eq? :-d.1001 #<0025>) getvectitem_75@opcodes)
              ((eq? :-d.1001 #<0026>) setvectitem_147@opcodes)
              (else (staticfail1000)))))))

(define opcode_for_float_primitive_146@prim_opc
  (lambda (x1)
    (let ((:-d.1002 x1))
      (cond ((eq? :-d.1002 #f) floatofint_116@opcodes)
            ((eq? :-d.1002 #t) negfloat_177@opcodes)
            ((eq? :-d.1002 #unspecified)
             addfloat_221@opcodes)
            ((eq? :-d.1002 #<0004>) subfloat_225@opcodes)
            ((eq? :-d.1002 #a000) mulfloat_26@opcodes)
            ((eq? :-d.1002 #<0006>) divfloat_252@opcodes)
            (else #f)))))

