(* Tk initialisation functions, event bindings, extensions *)

value OpenTk : unit -> Widget
and   OpenTkClass : string -> Widget
      (* Initialisation of the Tk interface, should be called only once.
         Both functions will return the toplevel widget.
         [OpenTkClass "class"] lets you specify the (resource) class 
         of the toplevel widget *)
;;

value MainLoop : unit -> unit 
      (* Enter the main loop for user interaction *)
;;

value CloseTk : unit -> unit
      (* Terminates the user-interface interaction *)
;;


value bind : Widget -> (Modifier list * XEvent) list -> BindAction -> unit
      (* Binding events to widgets *)
;;

value canvas_bind : Widget -> TagOrId 
     -> (Modifier list * XEvent) list -> BindAction -> unit
      (* Binding events to canvas objects *)
;;

value text_tag_bind : Widget -> string 
     -> (Modifier list * XEvent) list -> BindAction -> unit
      (* Binding events to tags in text widgets *)
;;

value class_bind : Widget -> string
     -> (Modifier list * XEvent) list -> BindAction -> unit
      (* Binding events for widget classes *)
;;
  
value add_fileinput : file_descr -> (unit -> unit) -> unit
and remove_fileinput : file_descr -> unit
      (* Callbacks on Unix file descriptors *)
;;
value update_idletasks : unit -> unit ;;
               (* tk function: update idletasks *)
value update : unit -> unit ;;
               (* tk function: update *)
value place : Widget -> option list -> unit ;;
               (* tk function: place *)
value pack : Widget list -> option list -> unit ;;
               (* tk function: pack *)
value lower : Widget -> unit ;;
               (* tk function: lower *)
value dialog : Widget -> string -> string -> string -> int -> string list -> int ;;
               (* tk function: tk_dialog *)
value destroy : Widget -> unit ;;
               (* tk function: destroy *)
