#open"protocol";;
#open"tk";;
#open"support";;
let create parent options =
   let buf = Send2TkStart true in
   Send2Tk buf "canvas";
   let w = new_widget_atom "canvas" parent in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_canvas_table x) options));
      Send2TkEval buf;
      w
;;
let create_named parent name options =
   let buf = Send2TkStart true in
   Send2Tk buf "canvas";
   let w = new_named_widget "canvas" parent name in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_canvas_table x) options));
      Send2TkEval buf;
      w
;;
let move w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "move";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (CAMLtoTKUnits a3);
	Send2TkEval buf; ()
;;

let createwindow w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create window";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_window_table x) a3));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let createtext w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create text";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_canvastext_table x) a3));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let createrectangle w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create rectangle";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_rectangle_table x) a3));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let createpolygon w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create polygon";
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKUnits x) a1));
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_polygon_table x) a2));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let createoval w a1 a2 a3 a4 a5 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create oval";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (CAMLtoTKUnits a3);
	Send2Tk buf (CAMLtoTKUnits a4);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_oval_table x) a5));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let createline w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create line";
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKUnits x) a1));
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_line_table x) a2));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let createbitmap w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create bitmap";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_bitmap_table x) a3));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let createarc w a1 a2 a3 a4 a5 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "create arc";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (CAMLtoTKUnits a3);
	Send2Tk buf (CAMLtoTKUnits a4);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_arc_table x) a5));
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let yview w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "yview";
	Send2Tk buf (CAMLtoTKCanvasIndex a);
	Send2TkEval buf; ()
;;

let xview w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "xview";
	Send2Tk buf (CAMLtoTKCanvasIndex a);
	Send2TkEval buf; ()
;;

let typeof w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "type";
	Send2Tk buf (CAMLtoTKTagOrId a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLCanvasItem (res_GetTkToken res);;

let select_to w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select to";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKCanvasIndex a2);
	Send2TkEval buf; ()
;;

let select_item w =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "select item";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLTagOrId (res_GetTkToken res);;

let select_from w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select from";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKCanvasIndex a2);
	Send2TkEval buf; ()
;;

let select_clear w =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select clear";
	Send2TkEval buf; ()
;;

let select_adjust w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select adjust";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKCanvasIndex a2);
	Send2TkEval buf; ()
;;

let scan_dragto w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "scan dragto";
	Send2Tk buf (string_of_int a1);
	Send2Tk buf (string_of_int a2);
	Send2TkEval buf; ()
;;

let scan_mark w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "scan mark";
	Send2Tk buf (string_of_int a1);
	Send2Tk buf (string_of_int a2);
	Send2TkEval buf; ()
;;

let scale w a1 a2 a3 a4 a5 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "scale";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (CAMLtoTKUnits a3);
	Send2Tk buf (string_of_float a4);
	Send2Tk buf (string_of_float a5);
	Send2TkEval buf; ()
;;

let raisetop w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "raise";
	Send2Tk buf (CAMLtoTKTagOrId a);
	Send2TkEval buf; ()
;;

let raiseabove w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "raise";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKTagOrId a2);
	Send2TkEval buf; ()
;;

let postscript_file w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "postscript -file";
	Send2Tk buf (quote_string a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_postscript_table x) a2));
	Send2TkEval buf; ()
;;

let postscript w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "postscript";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_postscript_table x)) a;
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let move w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "move";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf (CAMLtoTKUnits a3);
	Send2TkEval buf; ()
;;

let lowest w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "lower";
	Send2Tk buf (CAMLtoTKTagOrId a);
	Send2TkEval buf; ()
;;

let lower w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "lower";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKTagOrId a2);
	Send2TkEval buf; ()
;;

let window_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_window_table x) a2));
	Send2TkEval buf; ()
;;

let text_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_canvastext_table x) a2));
	Send2TkEval buf; ()
;;

let rectangle_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_rectangle_table x) a2));
	Send2TkEval buf; ()
;;

let polygon_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_polygon_table x) a2));
	Send2TkEval buf; ()
;;

let oval_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_oval_table x) a2));
	Send2TkEval buf; ()
;;

let line_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_line_table x) a2));
	Send2TkEval buf; ()
;;

let bitmap_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_bitmap_table x) a2));
	Send2TkEval buf; ()
;;

let arc_configure w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_arc_table x) a2));
	Send2TkEval buf; ()
;;

let item_configure_get w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "itemconfigure";
	Send2Tk buf (CAMLtoTKTagOrId a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let insert w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "insert";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKCanvasIndex a2);
	Send2Tk buf (quote_string a3);
	Send2TkEval buf; ()
;;

let index w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "index";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKCanvasIndex a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let icursor w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "icursor";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKCanvasIndex a2);
	Send2TkEval buf; ()
;;

let gettags w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "gettags";
	Send2Tk buf (CAMLtoTKTagOrId a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLTagOrId (res_GetTkTokenList res);;

let focus w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "focus";
	Send2Tk buf (CAMLtoTKTagOrId a);
	Send2TkEval buf; ()
;;

let focus_reset w =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "focus";
	Send2TkEval buf; ()
;;

let find w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "find";
	Send2Tk buf (CAMLtoTKSearchSpec a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLTagOrId (res_GetTkTokenList res);;

let dtag w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "dtag";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKTagOrId a2);
	Send2TkEval buf; ()
;;

let delete w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "delete";
	do_list (function x -> Send2Tk buf (CAMLtoTKTagOrId x)) a;
	Send2TkEval buf; ()
;;

let dchars w a1 a2 a3 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "dchars";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKCanvasIndex a2);
	Send2Tk buf (CAMLtoTKCanvasIndex a3);
	Send2TkEval buf; ()
;;

let coords_set w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "coords";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKUnits x) a2));
	Send2TkEval buf; ()
;;

let coords_get w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "coords";
	Send2Tk buf (CAMLtoTKTagOrId a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map int_of_string (res_GetTkTokenList res);;

let configure_get w =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let configure w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_label_table x)) a;
	Send2TkEval buf; ()
;;

let canvasy w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "canvasy";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let canvasx w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "canvasx";
	Send2Tk buf (CAMLtoTKUnits a1);
	Send2Tk buf (CAMLtoTKUnits a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let bbox w a =
	check_widget_class w "canvas";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "bbox";
	do_list (function x -> Send2Tk buf (CAMLtoTKTagOrId x)) a;
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	let r1 = float_of_string (res_GetTkToken res) in
	let r2 = float_of_string (res_GetTkToken res) in
	let r3 = float_of_string (res_GetTkToken res) in
	let r4 = float_of_string (res_GetTkToken res) in
r1,r2,r3,r4;;

let addtag w a1 a2 =
	check_widget_class w "canvas";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "addtag";
	Send2Tk buf (CAMLtoTKTagOrId a1);
	Send2Tk buf (CAMLtoTKSearchSpec a2);
	Send2TkEval buf; ()
;;

