(* The canvas widget *)
#open"tk";;
#open"support";;
value create : Widget -> option list -> Widget ;;
             (* [create p options] creates a new widget with parent p.
                Options are restricted to the widget class subset,
                and checked dynamically. *)
value create_named : Widget -> string -> option list -> Widget ;;
             (* [create p name options] creates a new widget with
                parent p and new patch component name.
                Options are restricted to the widget class subset,
                and checked dynamically. *)
value move : Widget -> TagOrId -> Units -> Units -> unit ;;
               (* tk command: .canvas move *)
value createwindow : Widget -> Units -> Units -> option list -> TagOrId ;;
               (* tk command: .canvas create window *)
value createtext : Widget -> Units -> Units -> option list -> TagOrId ;;
               (* tk command: .canvas create text *)
value createrectangle : Widget -> Units -> Units -> option list -> TagOrId ;;
               (* tk command: .canvas create rectangle *)
value createpolygon : Widget -> Units list -> option list -> TagOrId ;;
               (* tk command: .canvas create polygon *)
value createoval : Widget -> Units -> Units -> Units -> Units -> option list -> TagOrId ;;
               (* tk command: .canvas create oval *)
value createline : Widget -> Units list -> option list -> TagOrId ;;
               (* tk command: .canvas create line *)
value createbitmap : Widget -> Units -> Units -> option list -> TagOrId ;;
               (* tk command: .canvas create bitmap *)
value createarc : Widget -> Units -> Units -> Units -> Units -> option list -> TagOrId ;;
               (* tk command: .canvas create arc *)
value yview : Widget -> CanvasIndex -> unit ;;
               (* tk command: .canvas yview *)
value xview : Widget -> CanvasIndex -> unit ;;
               (* tk command: .canvas xview *)
value typeof : Widget -> TagOrId -> CanvasItem ;;
               (* tk command: .canvas type *)
value select_to : Widget -> TagOrId -> CanvasIndex -> unit ;;
               (* tk command: .canvas select to *)
value select_item : Widget -> TagOrId ;;
               (* tk command: .canvas select item *)
value select_from : Widget -> TagOrId -> CanvasIndex -> unit ;;
               (* tk command: .canvas select from *)
value select_clear : Widget -> unit ;;
               (* tk command: .canvas select clear *)
value select_adjust : Widget -> TagOrId -> CanvasIndex -> unit ;;
               (* tk command: .canvas select adjust *)
value scan_dragto : Widget -> int -> int -> unit ;;
               (* tk command: .canvas scan dragto *)
value scan_mark : Widget -> int -> int -> unit ;;
               (* tk command: .canvas scan mark *)
value scale : Widget -> TagOrId -> Units -> Units -> float -> float -> unit ;;
               (* tk command: .canvas scale *)
value raisetop : Widget -> TagOrId -> unit ;;
               (* tk command: .canvas raise *)
value raiseabove : Widget -> TagOrId -> TagOrId -> unit ;;
               (* tk command: .canvas raise *)
value postscript_file : Widget -> string -> option list -> unit ;;
               (* tk command: .canvas postscript -file *)
value postscript : Widget -> option list -> string ;;
               (* tk command: .canvas postscript *)
value move : Widget -> TagOrId -> Units -> Units -> unit ;;
               (* tk command: .canvas move *)
value lowest : Widget -> TagOrId -> unit ;;
               (* tk command: .canvas lower *)
value lower : Widget -> TagOrId -> TagOrId -> unit ;;
               (* tk command: .canvas lower *)
value window_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value text_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value rectangle_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value polygon_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value oval_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value line_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value bitmap_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value arc_configure : Widget -> TagOrId -> option list -> unit ;;
               (* tk command: .canvas itemconfigure *)
value item_configure_get : Widget -> TagOrId -> string ;;
               (* tk command: .canvas itemconfigure *)
value insert : Widget -> TagOrId -> CanvasIndex -> string -> unit ;;
               (* tk command: .canvas insert *)
value index : Widget -> TagOrId -> CanvasIndex -> int ;;
               (* tk command: .canvas index *)
value icursor : Widget -> TagOrId -> CanvasIndex -> unit ;;
               (* tk command: .canvas icursor *)
value gettags : Widget -> TagOrId -> TagOrId list ;;
               (* tk command: .canvas gettags *)
value focus : Widget -> TagOrId -> unit ;;
               (* tk command: .canvas focus *)
value focus_reset : Widget -> unit ;;
               (* tk command: .canvas focus *)
value find : Widget -> SearchSpec -> TagOrId list ;;
               (* tk command: .canvas find *)
value dtag : Widget -> TagOrId -> TagOrId -> unit ;;
               (* tk command: .canvas dtag *)
value delete : Widget -> TagOrId list -> unit ;;
               (* tk command: .canvas delete *)
value dchars : Widget -> TagOrId -> CanvasIndex -> CanvasIndex -> unit ;;
               (* tk command: .canvas dchars *)
value coords_set : Widget -> TagOrId -> Units list -> unit ;;
               (* tk command: .canvas coords *)
value coords_get : Widget -> TagOrId -> int list ;;
               (* tk command: .canvas coords *)
value configure_get : Widget -> string ;;
               (* tk command: .canvas configure *)
value configure : Widget -> option list -> unit ;;
               (* tk command: .canvas configure *)
value canvasy : Widget -> Units -> Units -> int ;;
               (* tk command: .canvas canvasy *)
value canvasx : Widget -> Units -> Units -> int ;;
               (* tk command: .canvas canvasx *)
value bbox : Widget -> TagOrId list -> float * float * float * float ;;
               (* tk command: .canvas bbox *)
value addtag : Widget -> TagOrId -> SearchSpec -> unit ;;
               (* tk command: .canvas addtag *)
