#open"protocol";;
#open"tk";;
#open"support";;
let create parent options =
   let buf = Send2TkStart true in
   Send2Tk buf "entry";
   let w = new_widget_atom "entry" parent in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_entry_table x) options));
      Send2TkEval buf;
      w
;;
let create_named parent name options =
   let buf = Send2TkStart true in
   Send2Tk buf "entry";
   let w = new_named_widget "entry" parent name in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_entry_table x) options));
      Send2TkEval buf;
      w
;;
let view w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "view";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a);
	Send2TkEval buf; ()
;;

let select_to w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "selectto";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a);
	Send2TkEval buf; ()
;;

let select_from w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "selectfrom";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a);
	Send2TkEval buf; ()
;;

let select_clear w =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "selectclear";
	Send2TkEval buf; ()
;;

let select_adjust w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "selectadjust";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a);
	Send2TkEval buf; ()
;;

let scan_dragto w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "scandragto";
	Send2Tk buf (string_of_int a);
	Send2TkEval buf; ()
;;

let scan_mark w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "scanmark";
	Send2Tk buf (string_of_int a);
	Send2TkEval buf; ()
;;

let insert w a1 a2 =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "insert";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a1);
	Send2Tk buf (quote_string a2);
	Send2TkEval buf; ()
;;

let index w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "index";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a);
	Send2TkEval buf; ()
;;

let icursor w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "icursor";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a);
	Send2TkEval buf; ()
;;

let get w =
	check_widget_class w "entry";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "get";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let delete w a1 a2 =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "delete";
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a1);
	Send2Tk buf (CAMLtoTKIndex Index_entry_table a2);
	Send2TkEval buf; ()
;;

let configure_get w =
	check_widget_class w "entry";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let configure w a =
	check_widget_class w "entry";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_entry_table x)) a;
	Send2TkEval buf; ()
;;

