#open"protocol";;
#open"tk";;
#open"support";;
let create parent options =
   let buf = Send2TkStart true in
   Send2Tk buf "listbox";
   let w = new_widget_atom "listbox" parent in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_listbox_table x) options));
      Send2TkEval buf;
      w
;;
let create_named parent name options =
   let buf = Send2TkStart true in
   Send2Tk buf "listbox";
   let w = new_named_widget "listbox" parent name in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_listbox_table x) options));
      Send2TkEval buf;
      w
;;
let yview w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "yview";
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a);
	Send2TkEval buf; ()
;;

let xview w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "xview";
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a);
	Send2TkEval buf; ()
;;

let size w =
	check_widget_class w "listbox";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "size";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let select_to w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select to";
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a);
	Send2TkEval buf; ()
;;

let select_from w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select from";
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a);
	Send2TkEval buf; ()
;;

let select_clear w =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select clear";
	Send2TkEval buf; ()
;;

let select_adjust w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "select adjust";
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a);
	Send2TkEval buf; ()
;;

let scan_dragto w a1 a2 =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "scandragto";
	Send2Tk buf (string_of_int a1);
	Send2Tk buf (string_of_int a2);
	Send2TkEval buf; ()
;;

let scan_mark w a1 a2 =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "scanmark";
	Send2Tk buf (string_of_int a1);
	Send2Tk buf (string_of_int a2);
	Send2TkEval buf; ()
;;

let nearest w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "nearest";
	Send2Tk buf (string_of_int a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLIndex (res_GetTkToken res);;

let insert w a1 a2 =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "insert";
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a1);
	Send2Tk buf (catenate_sep " " (map (function x -> quote_string x) a2));
	Send2TkEval buf; ()
;;

let get w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "get";
	Send2Tk buf (CAMLtoTKIndex Index_listboxget_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let delete w a1 a2 =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "delete";
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a1);
	Send2Tk buf (CAMLtoTKIndex Index_listbox_table a2);
	Send2TkEval buf; ()
;;

let curselection w =
	check_widget_class w "listbox";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "curselection";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLIndex (res_GetTkTokenList res);;

let configure_get w =
	check_widget_class w "listbox";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let configure w a =
	check_widget_class w "listbox";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_listbox_table x)) a;
	Send2TkEval buf; ()
;;

