#open"protocol";;
#open"tk";;
#open"support";;
let create parent options =
   let buf = Send2TkStart true in
   Send2Tk buf "menu";
   let w = new_widget_atom "menu" parent in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_menu_table x) options));
      Send2TkEval buf;
      w
;;
let create_named parent name options =
   let buf = Send2TkStart true in
   Send2Tk buf "menu";
   let w = new_named_widget "menu" parent name in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_menu_table x) options));
      Send2TkEval buf;
      w
;;
let yposition w a =
	check_widget_class w "menu";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "yposition";
	Send2Tk buf (CAMLtoTKMenuIndex a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let unpost w =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "unpost";
	Send2TkEval buf; ()
;;

let post w a1 a2 =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "post";
	Send2Tk buf (string_of_int a1);
	Send2Tk buf (string_of_int a2);
	Send2TkEval buf; ()
;;

let invoke w a =
	check_widget_class w "menu";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "invoke";
	Send2Tk buf (CAMLtoTKMenuIndex a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let index w a =
	check_widget_class w "menu";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "index";
	Send2Tk buf (CAMLtoTKMenuIndex a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let entryconfigure_get w a =
	check_widget_class w "menu";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "entryconfigure";
	Send2Tk buf (CAMLtoTKMenuIndex a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let entryconfigure_radiobutton w a1 a2 =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "entryconfigure";
	Send2Tk buf (CAMLtoTKMenuIndex a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_menuradio_table x) a2));
	Send2TkEval buf; ()
;;

let entryconfigure_command w a1 a2 =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "entryconfigure";
	Send2Tk buf (CAMLtoTKMenuIndex a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_menucommand_table x) a2));
	Send2TkEval buf; ()
;;

let entryconfigure_checkbutton w a1 a2 =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "entryconfigure";
	Send2Tk buf (CAMLtoTKMenuIndex a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_menucheck_table x) a2));
	Send2TkEval buf; ()
;;

let entryconfigure_cascade w a1 a2 =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "entryconfigure";
	Send2Tk buf (CAMLtoTKMenuIndex a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_menucascade_table x) a2));
	Send2TkEval buf; ()
;;

let enable w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "enable";
	Send2Tk buf (CAMLtoTKMenuIndex a);
	Send2TkEval buf; ()
;;

let disable w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "disable";
	Send2Tk buf (CAMLtoTKMenuIndex a);
	Send2TkEval buf; ()
;;

let delete w a1 a2 =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "delete";
	Send2Tk buf (CAMLtoTKMenuIndex a1);
	Send2Tk buf (CAMLtoTKMenuIndex a2);
	Send2TkEval buf; ()
;;

let configure w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_menu_table x)) a;
	Send2TkEval buf; ()
;;

let add_separator w =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "add separator";
	Send2TkEval buf; ()
;;

let add_radiobutton w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "add radiobutton";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_menuradio_table x)) a;
	Send2TkEval buf; ()
;;

let add_command w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "add command";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_menucommand_table x)) a;
	Send2TkEval buf; ()
;;

let add_checkbutton w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "add checkbutton";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_menucheck_table x)) a;
	Send2TkEval buf; ()
;;

let add_cascade w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "add cascade";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_menucascade_table x)) a;
	Send2TkEval buf; ()
;;

let activate w a =
	check_widget_class w "menu";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "activate";
	Send2Tk buf (CAMLtoTKMenuIndex a);
	Send2TkEval buf; ()
;;

