#open"protocol";;
#open"tk";;
#open"support";;
let create parent options =
   let buf = Send2TkStart true in
   Send2Tk buf "text";
   let w = new_widget_atom "text" parent in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_text_table x) options));
      Send2TkEval buf;
      w
;;
let create_named parent name options =
   let buf = Send2TkStart true in
   Send2Tk buf "text";
   let w = new_named_widget "text" parent name in
      Send2Tk buf (widget_name w);
      Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_text_table x) options));
      Send2TkEval buf;
      w
;;
let yview_pickplace_line w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "yview -pickplace";
	Send2Tk buf (string_of_int a);
	Send2TkEval buf; ()
;;

let yview_pickplace w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "yview -pickplace";
	Send2Tk buf (CAMLtoTKTextIndex a);
	Send2TkEval buf; ()
;;

let yview_line w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "yview";
	Send2Tk buf (string_of_int a);
	Send2TkEval buf; ()
;;

let yview w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "yview";
	Send2Tk buf (CAMLtoTKTextIndex a);
	Send2TkEval buf; ()
;;

let tag_remove_char w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag remove";
	Send2Tk buf (CAMLtoTKTextTag a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2TkEval buf; ()
;;

let tag_remove w a1 a2 a3 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag remove";
	Send2Tk buf (CAMLtoTKTextTag a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2Tk buf (CAMLtoTKTextIndex a3);
	Send2TkEval buf; ()
;;

let tag_ranges w a =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag ranges";
	Send2Tk buf (CAMLtoTKTextTag a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLBaseTextIndex (res_GetTkTokenList res);;

let tag_raisetop w =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag raise";
	Send2TkEval buf; ()
;;

let tag_raise w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag raise";
	Send2Tk buf (CAMLtoTKTextTag a);
	Send2TkEval buf; ()
;;

let tag_nextrange w a1 a2 a3 =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag nextrange";
	Send2Tk buf (CAMLtoTKTextTag a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2Tk buf (CAMLtoTKTextIndex a3);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	let r1 = TKtoCAMLBaseTextIndex (res_GetTkToken res) in
	let r2 = TKtoCAMLBaseTextIndex (res_GetTkToken res) in
r1,r2;;

let tag_indexnames w a =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag names";
	Send2Tk buf (CAMLtoTKTextIndex a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLTextTag (res_GetTkTokenList res);;

let tag_allnames w =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag names";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLTextTag (res_GetTkTokenList res);;

let tag_lowest w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag lower";
	Send2Tk buf (CAMLtoTKTextTag a);
	Send2TkEval buf; ()
;;

let tag_lower w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag lower";
	Send2Tk buf (CAMLtoTKTextTag a1);
	Send2Tk buf (CAMLtoTKTextTag a2);
	Send2TkEval buf; ()
;;

let tag_delete w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag delete";
	do_list (function x -> Send2Tk buf (CAMLtoTKTextTag x)) a;
	Send2TkEval buf; ()
;;

let tag_configure w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag configure";
	Send2Tk buf (CAMLtoTKTextTag a1);
	Send2Tk buf (catenate_sep " " (map (function x -> CAMLtoTKoption option_texttag_table x) a2));
	Send2TkEval buf; ()
;;

let tag_add_char w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag add";
	Send2Tk buf (CAMLtoTKTextTag a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2TkEval buf; ()
;;

let tag_add w a1 a2 a3 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "tag add";
	Send2Tk buf (CAMLtoTKTextTag a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2Tk buf (CAMLtoTKTextIndex a3);
	Send2TkEval buf; ()
;;

let scan_dragto w a =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "scan dragto";
	Send2Tk buf (string_of_int a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let scan_mark w a =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "scan mark";
	Send2Tk buf (string_of_int a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let mark_unset w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "mark unset";
	do_list (function x -> Send2Tk buf (CAMLtoTKTextMark x)) a;
	Send2TkEval buf; ()
;;

let mark_set w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "mark set";
	Send2Tk buf (CAMLtoTKTextMark a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2TkEval buf; ()
;;

let mark_names w =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "mark names";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLTextMark (res_GetTkTokenList res);;

let insert w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "insert";
	Send2Tk buf (CAMLtoTKTextIndex a1);
	Send2Tk buf (quote_string a2);
	Send2TkEval buf; ()
;;

let index w a =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "index";
	Send2Tk buf (CAMLtoTKTextIndex a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLBaseTextIndex (res_GetTkToken res);;

let get_char w a =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "get";
	Send2Tk buf (CAMLtoTKTextIndex a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let get w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "get";
	Send2Tk buf (CAMLtoTKTextIndex a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let delete_char w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "delete";
	Send2Tk buf (CAMLtoTKTextIndex a);
	Send2TkEval buf; ()
;;

let delete w a1 a2 =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "delete";
	Send2Tk buf (CAMLtoTKTextIndex a1);
	Send2Tk buf (CAMLtoTKTextIndex a2);
	Send2TkEval buf; ()
;;

let debug w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "debug";
	Send2Tk buf (if a then "1" else "0");
	Send2TkEval buf; ()
;;

let configure_get w =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let configure w a =
	check_widget_class w "text";
	let buf = Send2TkStart false in 
	Send2Tk buf (widget_name w);
	Send2Tk buf "configure";
	do_list (function x -> Send2Tk buf (CAMLtoTKoption option_text_table x)) a;
	Send2TkEval buf; ()
;;

let compare w a1 a2 a3 =
	check_widget_class w "text";
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf (widget_name w);
	Send2Tk buf "compare";
	Send2Tk buf (CAMLtoTKTextIndex a1);
	Send2Tk buf (CAMLtoTKComparison a2);
	Send2Tk buf (CAMLtoTKTextIndex a3);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	match (res_GetTkToken res) with
       	     "0" -> true
           | "1" -> false
           | _ -> raise (Invalid_argument "TKtoCAMLbool");;

