(* The text widget *)
#open"tk";;
#open"support";;
value create : Widget -> option list -> Widget ;;
             (* [create p options] creates a new widget with parent p.
                Options are restricted to the widget class subset,
                and checked dynamically. *)
value create_named : Widget -> string -> option list -> Widget ;;
             (* [create p name options] creates a new widget with
                parent p and new patch component name.
                Options are restricted to the widget class subset,
                and checked dynamically. *)
value yview_pickplace_line : Widget -> int -> unit ;;
               (* tk command: .text yview -pickplace *)
value yview_pickplace : Widget -> TextIndex -> unit ;;
               (* tk command: .text yview -pickplace *)
value yview_line : Widget -> int -> unit ;;
               (* tk command: .text yview *)
value yview : Widget -> TextIndex -> unit ;;
               (* tk command: .text yview *)
value tag_remove_char : Widget -> TextTag -> TextIndex -> unit ;;
               (* tk command: .text tag remove *)
value tag_remove : Widget -> TextTag -> TextIndex -> TextIndex -> unit ;;
               (* tk command: .text tag remove *)
value tag_ranges : Widget -> TextTag -> BaseTextIndex list ;;
               (* tk command: .text tag ranges *)
value tag_raisetop : Widget -> unit ;;
               (* tk command: .text tag raise *)
value tag_raise : Widget -> TextTag -> unit ;;
               (* tk command: .text tag raise *)
value tag_nextrange : Widget -> TextTag -> TextIndex -> TextIndex -> BaseTextIndex * BaseTextIndex ;;
               (* tk command: .text tag nextrange *)
value tag_indexnames : Widget -> TextIndex -> TextTag list ;;
               (* tk command: .text tag names *)
value tag_allnames : Widget -> TextTag list ;;
               (* tk command: .text tag names *)
value tag_lowest : Widget -> TextTag -> unit ;;
               (* tk command: .text tag lower *)
value tag_lower : Widget -> TextTag -> TextTag -> unit ;;
               (* tk command: .text tag lower *)
value tag_delete : Widget -> TextTag list -> unit ;;
               (* tk command: .text tag delete *)
value tag_configure : Widget -> TextTag -> option list -> unit ;;
               (* tk command: .text tag configure *)
value tag_add_char : Widget -> TextTag -> TextIndex -> unit ;;
               (* tk command: .text tag add *)
value tag_add : Widget -> TextTag -> TextIndex -> TextIndex -> unit ;;
               (* tk command: .text tag add *)
value scan_dragto : Widget -> int -> int ;;
               (* tk command: .text scan dragto *)
value scan_mark : Widget -> int -> int ;;
               (* tk command: .text scan mark *)
value mark_unset : Widget -> TextMark list -> unit ;;
               (* tk command: .text mark unset *)
value mark_set : Widget -> TextMark -> TextIndex -> unit ;;
               (* tk command: .text mark set *)
value mark_names : Widget -> TextMark list ;;
               (* tk command: .text mark names *)
value insert : Widget -> TextIndex -> string -> unit ;;
               (* tk command: .text insert *)
value index : Widget -> TextIndex -> BaseTextIndex ;;
               (* tk command: .text index *)
value get_char : Widget -> TextIndex -> string ;;
               (* tk command: .text get *)
value get : Widget -> TextIndex -> TextIndex -> string ;;
               (* tk command: .text get *)
value delete_char : Widget -> TextIndex -> unit ;;
               (* tk command: .text delete *)
value delete : Widget -> TextIndex -> TextIndex -> unit ;;
               (* tk command: .text delete *)
value debug : Widget -> bool -> unit ;;
               (* tk command: .text debug *)
value configure_get : Widget -> string ;;
               (* tk command: .text configure *)
value configure : Widget -> option list -> unit ;;
               (* tk command: .text configure *)
value compare : Widget -> TextIndex -> Comparison -> TextIndex -> bool ;;
               (* tk command: .text compare *)
