#open"protocol";;
#open"tk";;
#open"support";;
let atom a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo atom";
	Send2Tk buf (quote_string a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLAtomId (res_GetTkToken res);;

let atomname a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo atomname";
	Send2Tk buf (CAMLtoTKAtomId a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let cells a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo cells";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let children a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo children";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLWidget (res_GetTkTokenList res);;

let class a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo class";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let containing a1 a2 =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo containing";
	Send2Tk buf (string_of_int a1);
	Send2Tk buf (string_of_int a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLWidget (res_GetTkToken res);;

let depth a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo depth";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let exists a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo exists";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	match (res_GetTkToken res) with
       	     "0" -> true
           | "1" -> false
           | _ -> raise (Invalid_argument "TKtoCAMLbool");;

let fpixels a1 a2 =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo fpixels";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a1);
	Send2Tk buf (string_of_int a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	float_of_string (res_GetTkToken res);;

let geometry a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo geometry";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let height a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo height";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let id a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo id";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let interps () =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo interps";
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	map TKtoCAMLsymbol (res_GetTkTokenList res);;

let ismapped a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo ismapped";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	match (res_GetTkToken res) with
       	     "0" -> true
           | "1" -> false
           | _ -> raise (Invalid_argument "TKtoCAMLbool");;

let name a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo name";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let parent a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo parent";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLWidget (res_GetTkToken res);;

let pathname a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo pathname";
	Send2Tk buf (quote_string a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLWidget (res_GetTkToken res);;

let pixels a1 a2 =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo pixels";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a1);
	Send2Tk buf (string_of_int a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let reqheight a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo reqheight";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let reqwidth a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo reqwidth";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let rgb a1 a2 =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo rgb";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a1);
	Send2Tk buf (CAMLtoTKColor a2);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	let r1 = int_of_string (res_GetTkToken res) in
	let r2 = int_of_string (res_GetTkToken res) in
	let r3 = int_of_string (res_GetTkToken res) in
r1,r2,r3;;

let rootx a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo rootx";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let rooty a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo rooty";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let screen a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo screen";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let screencells a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo screencells";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let screendepth a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo screendepth";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let screenheight a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo screenheight";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let screenmmdepth a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo screenmmdepth";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let screenmmheight a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo screenmmheight";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let screenvisual a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo screenvisual";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let screenwidth a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo screenwidth";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let toplevel a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo toplevel";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	TKtoCAMLWidget (res_GetTkToken res);;

let visual a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_string_header;
	Send2Tk buf "winfo visual";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
(res_GetTkString res);;

let vrootheight a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo vrootheight";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let vrootwidth a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo vrootwidth";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let vrootx a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo vrootx";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let vrooty a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo vrooty";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let width a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo width";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let x a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo x";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

let y a =
	let buf = Send2TkStart true in 
	Send2Tk buf result_header;
	Send2Tk buf "winfo y";
	Send2Tk buf (CAMLtoTKWidget Widget_any_table a);
	Send2Tk buf result_footer;
	let res = Send2TkEval buf in
	int_of_string (res_GetTkToken res);;

