;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*=====================================================================*/
;*    serrano/prgm/project/camloo/runtime0.3/Llib/constr.scm ...       */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Dec  7 08:24:20 1993                          */
;*    Last change :  Thu Dec  1 08:35:01 1994 (serrano)                */
;*    -------------------------------------------------------------    */
;*    La gestion (bigloo) des constructeurs                            */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module __caml_constr
   (foreign (include "caml-bigloo.h")
	    ;; le createur de tag
            (define obj caml-make-tag (int int)
	       "CAML_MAKE_TAG")
	    ;; les allocateurs
	    (define obj caml-allocate-regular-constr (obj)
	       "CAML_ALLOCATE_REGULAR_CONSTR")
	    (obj caml-make-regular    (obj obj . obj)
		 "caml_make_regular")
	    (obj caml-make-regular-1  (obj obj)
		 "caml_make_regular_1")
	    (obj caml-make-regular-2  (obj obj obj)
		 "caml_make_regular_2")
	    (obj caml-make-regular-3  (obj obj obj obj)
		 "caml_make_regular_3")
	    (obj caml-make-regular-4  (obj obj obj obj obj)
		 "caml_make_regular_4")
	    (obj caml-make-extensible (obj obj . obj)
		 "caml_make_extensible")
	    (obj caml-make-extensible-1  (obj obj)
		 "caml_make_extensible_1")
	    (obj caml-make-extensible-2  (obj obj obj)
		 "caml_make_extensible_2")
	    (obj caml-make-extensible-3  (obj obj obj obj)
		 "caml_make_extensible_3")
	    (obj caml-make-extensible-4  (obj obj obj obj obj)
		 "caml_make_extensible_4")
	    ;; les predicats
	    (define bool caml-constant-constr? (obj)
	       "CAML_CONSTANT_CONSTRP")
	    (define bool caml-regular-constr? (obj)
	       "CAML_REGULAR_CONSTRP")
	    (define bool may-be-an-extensible-constr? (obj)
	       "MAY_BE_AN_CAML_EXTENSIBLE_CONSTRP")
	    (define bool caml-extensible-constr? (obj)
	       "CAML_EXTENSIBLE_CONSTRP")
	    ;; les longeurs
	    (define obj caml-regular-constr-length   (obj)
	       "CAML_REGULAR_CONSTR_LENGTH")
	    ;; les tags
	    (define obj caml-constr-tag  (obj)
	       "CAML_CONSTR_TAG")
	    (define obj caml-constant-constr-tag (obj)
	       "_CAML_CNST_CONSTR_TAG")
	    (define obj caml-regular-constr-tag (obj)
	       "CAML_REGULAR_CONSTR_TAG")
	    (define obj caml-extensible-constr-tag (obj)
	       "CAML_EXTENSIBLE_CONSTR_TAG")
	    ;; les trippotages des tags
	    (define obj vector-replace-tag! (obj obj)
	       "VECTOR_REPLACE_TAG")
	    (define obj caml-regular-constr-set-tag! (obj obj)
	       "CAML_REGULAR_CONSTR_SET_TAG")
	    ;; les acces aux champs
	    (define obj caml-constr-get-field  (obj bint)
	       "CAML_CONSTR_GET_FIELD")
	    (define obj caml-constr-set-field! (obj bint obj)
	       "CAML_CONSTR_SET_FIELD")
	    (define obj  init-stack-regular-1 (obj obj)
	       "INIT_STACK_REGULAR_1")
	    (define obj  init-stack-regular-2 (obj obj obj)
	       "INIT_STACK_REGULAR_2")
	    (define obj  init-stack-regular-3 (obj obj obj obj)
	       "INIT_STACK_REGULAR_3")
	    (define obj  init-stack-regular-4 (obj obj obj obj obj)
	       "INIT_STACK_REGULAR_4")
	    (define obj  sregular-ref (obj) "SREGULAR_REF"))
   (export  (caml-constr-update! c1 c2)
	    (inline caml-make-static-extensible-1 obj obj)
	    (inline caml-make-static-extensible-2 obj obj obj)
	    (inline caml-make-static-extensible-3 obj obj obj obj)
	    (inline caml-make-static-extensible-4 obj obj obj obj obj)
	    *the-static-extensible-1*
	    *the-static-extensible-2*
	    *the-static-extensible-3*
	    *the-static-extensible-4*
	    (init-static-extensible!)
	    (caml-copy-extensible constr))
   (pragma  (caml-make-tag _no_side_effect_ _no_mutation_ _imbricable_)
	    (caml-make-regular-1 _no_mutation_ 
				 _allocater_
				 #(init-stack-regular-1
				   "svector_t( 1 )"
				   sregular-ref
				   fixed-length))
	    (caml-make-regular-2 _no_mutation_ 
				 _allocater_
				 #(init-stack-regular-2
				  "svector_t( 2 )"
				  sregular-ref
				  fixed-length))
	    (caml-make-regular-3 _no_mutation_ 
				 _allocater_
				 #(init-stack-regular-3
				  "svector_t( 3 )"
				  sregular-ref
				  fixed-length))
	    (caml-make-regular-4 _no_mutation_ 
				 _allocater_
				 #(init-stack-regular-4
				  "svector_t( 4 )"
				  sregular-ref
				  fixed-length))
            (caml-constr-set-field! _dont_return_but_ ((2 . 0)))
            (caml-constr-get-field _no_side_effect_ _no_mutation_ _imbricable_
				   _dont_return_)
	    (caml-constant-constr? _no_side_effect_ _imutable_
				   _no_mutation_ _imbricable_
				   _dont_return_)
	    (caml-regular-constr? _no_side_effect_ _imutable_
				  _no_mutation_ _imbricable_)
	    (caml-extensible-constr? _no_side_effect_ _imutable_
				     _no_mutation_ _imbricable_)
	    (caml-constant-constr-tag _no_side_effect_ _imutable_
				      _no_mutation_ _imbricable_)
	    (caml-regular-constr-tag _no_side_effect_ _imutable_
				      _no_mutation_ _imbricable_)
	    (caml-extensible-constr-tag _no_side_effect_ _imutable_
					_no_mutation_ _imbricable_)))

;*---------------------------------------------------------------------*/
;*    caml-constr-update! ...                                          */
;*---------------------------------------------------------------------*/
(define (caml-constr-update! c1 c2)
   (cond
      ((and (vector? c1) (vector? c2))
       (if (>=fx (vector-length c1) (vector-length c2))
	   (begin
	      (vector-replace-tag! c1 c2)
	      (let loop ((i (-fx (vector-length c2) 1)))
		 (if (=fx i -1)
		     'done
		     (begin
			(vector-set! c1 i (vector-ref c2 i))
			(loop (-fx i 1))))))
	   (error "Illegal vector update" c1 c2)))
      ((and (procedure? c1) (procedure? c2))
       (error "Illegal procedure update" c1 c2))
      ((and (pair? c1) (pair? c2))
       (set-car! c1 (car c2))
       (set-cdr! c1 (cdr c2)))
      ((caml-constant-constr? c2)
       (caml-regular-constr-set-tag! c1 (caml-constant-constr-tag c2))
       c1)
      (else
       (error "Illegal update" c1 c2))))

;*---------------------------------------------------------------------*/
;*    Les constructeurs extensibles statiques (pre-alloues).           */
;*---------------------------------------------------------------------*/
(define *the-static-extensible-1* (unspecified))
(define *the-static-extensible-2* (unspecified))
(define *the-static-extensible-3* (unspecified))
(define *the-static-extensible-4* (unspecified))

;*---------------------------------------------------------------------*/
;*    init-static-extensible! ...                                      */
;*---------------------------------------------------------------------*/
(define (init-static-extensible!)
   (set! *the-static-extensible-1*
	 (caml-make-extensible-1 (unspecified)
				 (unspecified)))
   (set! *the-static-extensible-2*
	 (caml-make-extensible-2 (unspecified)
				 (unspecified)
				 (unspecified)))
   (set! *the-static-extensible-3*
	 (caml-make-extensible-3 (unspecified)
				 (unspecified)
				 (unspecified)
				 (unspecified)))
   (set! *the-static-extensible-4*
	 (caml-make-extensible-4 (unspecified)
				 (unspecified)
				 (unspecified)
				 (unspecified)
				 (unspecified))))
   
;*---------------------------------------------------------------------*/
;*    caml-make-static-extensible-1 ...                                */
;*---------------------------------------------------------------------*/
(define-inline (caml-make-static-extensible-1 tag val0)
   (begin
      (caml-constr-set-field! *the-static-extensible-1* 0 val0)
      (caml-constr-set-field! *the-static-extensible-1* 1 tag)
      *the-static-extensible-1*))

;*---------------------------------------------------------------------*/
;*    caml-make-static-extensible-2 ...                                */
;*---------------------------------------------------------------------*/
(define-inline (caml-make-static-extensible-2 tag val0 val1)
   (begin
      (caml-constr-set-field! *the-static-extensible-2* 0 val0)
      (caml-constr-set-field! *the-static-extensible-2* 1 val1)
      (caml-constr-set-field! *the-static-extensible-2* 2 tag)
      *the-static-extensible-2*))

;*---------------------------------------------------------------------*/
;*    caml-make-static-extensible-3 ...                                */
;*---------------------------------------------------------------------*/
(define-inline (caml-make-static-extensible-3 tag val0 val1 val2)
   (begin
      (caml-constr-set-field! *the-static-extensible-3* 0 val0)
      (caml-constr-set-field! *the-static-extensible-3* 1 val1)
      (caml-constr-set-field! *the-static-extensible-3* 2 val2)
      (caml-constr-set-field! *the-static-extensible-3* 3 tag)
      *the-static-extensible-3*))

;*---------------------------------------------------------------------*/
;*    caml-make-static-extensible-4 ...                                */
;*---------------------------------------------------------------------*/
(define-inline (caml-make-static-extensible-4 tag val0 val1 val2 val3)
   (begin
      (caml-constr-set-field! *the-static-extensible-4* 0 val0)
      (caml-constr-set-field! *the-static-extensible-4* 1 val1)
      (caml-constr-set-field! *the-static-extensible-4* 2 val2)
      (caml-constr-set-field! *the-static-extensible-4* 3 val3)
      (caml-constr-set-field! *the-static-extensible-4* 4 tag)
      *the-static-extensible-4*))

;*---------------------------------------------------------------------*/
;*    caml-copy-extensible ...                                         */
;*    -------------------------------------------------------------    */
;*    Pour faire cette fonction on est oblige de savoir que            */
;*    les extensibles sont implemante par des vecteurs (ne serait-ce   */
;*    que pour calculer la taille de l'extensible).                    */
;*---------------------------------------------------------------------*/
(define (caml-copy-extensible constr)
   (cond
      ((vector? constr)
       (let* ((tag        (caml-extensible-constr-tag constr))
	      (size       (vector-length constr))
	      (new-constr (make-vector size)))
	  (vector-tag-set! new-constr (vector-tag constr))
	  (let loop ((size (-fx size 1)))
	     (if (=fx size -1)
		 new-constr
		 (begin
		    (vector-set! new-constr size (vector-ref constr size))
		    (loop (-fx size 1)))))))
      ((symbol? constr)
       constr)
      (else
       (error "caml-copy-extensible" "Illegal constructor" constr))))
       

